=begin
#Visualization API

#Generates server side renderings of D3 visualizations for a nodejs backend

OpenAPI spec version: 0.1.0
Contact: info@researchable.nl
Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require "uri"

module VisualizationJsApi
  class DefaultApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    #
    # Renders a graph in PNG format
    # @param graph_definition The graph definition object
    # @param [Hash] opts the optional parameters
    # @return [String]
    def render_png_post(graph_definition, opts = {})
      data, _status_code, _headers = render_png_post_with_http_info(graph_definition, opts)
      return data
    end

    #
    # Renders a graph in PNG format
    # @param graph_definition The graph definition object
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def render_png_post_with_http_info(graph_definition, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DefaultApi.render_png_post ..."
      end
      # verify the required parameter 'graph_definition' is set
      fail ArgumentError, "Missing the required parameter 'graph_definition' when calling DefaultApi.render_png_post" if graph_definition.nil?
      # resource path
      local_var_path = "/render.png".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['image/png']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = []
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(graph_definition)
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DefaultApi#render_png_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    #
    # Renders a graph in SVG format
    # @param graph_definition The graph definition object
    # @param [Hash] opts the optional parameters
    # @return [String]
    def render_svg_post(graph_definition, opts = {})
      data, _status_code, _headers = render_svg_post_with_http_info(graph_definition, opts)
      return data
    end

    #
    # Renders a graph in SVG format
    # @param graph_definition The graph definition object
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def render_svg_post_with_http_info(graph_definition, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DefaultApi.render_svg_post ..."
      end
      # verify the required parameter 'graph_definition' is set
      fail ArgumentError, "Missing the required parameter 'graph_definition' when calling DefaultApi.render_svg_post" if graph_definition.nil?
      # resource path
      local_var_path = "/render.svg".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['image/svg']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = []
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(graph_definition)
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DefaultApi#render_svg_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
